#!/usr/bin/perl
# ----- t02.t ---------------------------------------------------
# vim:set syntax=perl:
# almost verbatim copy from the Dazuko::IO(3) manpage

use strict;

my $loaded = 0;
my $mayblock = 0; # set to 0 to have the test NOT block

BEGIN { $| = 1; print "1..9\n"; }
use Dazuko::IO qw( $DAZUKO_ON_OPEN $DAZUKO_ON_CLOSE );
$loaded = 1;
print "ok 1\n";
END { print "not ok 1\n" unless $loaded; }

my (
	@acc, $rc, $group, $mode, $mask, $path, $ref, $deny,
	$event, $flags, $uid, $pid, $filename, $filesize,
	$fileuid, $filegid, $filemode, $filedevice,
);

sub checkAccess(@) {
  return(0);
}

$group = "Vendor:App"; $mode = "rw";
$rc = Dazuko::IO::Register($group, $mode);
print $rc == 0 ? "" : "not ", "ok 2\n";
$mask = $DAZUKO_ON_OPEN | $DAZUKO_ON_CLOSE;
$rc = Dazuko::IO::SetAccessMask($mask);
print $rc == 0 ? "" : "not ", "ok 3\n";
foreach $path (qw( /home /data )) {
  $rc = Dazuko::IO::AddIncludePath($path);
  last if ($rc != 0);
}
print $rc == 0 ? "" : "not ", "ok 4\n";
foreach $path (qw( /dev/null /proc )) {
  $rc = Dazuko::IO::AddExcludePath($path);
  last if ($rc != 0);
}
print $rc == 0 ? "" : "not ", "ok 5\n";

if ($mayblock) {
  while (@acc = Dazuko::IO::GetAccess()) {
    print @acc ? "" : "not ", "ok 6\n";
    ( $ref, $deny, $event, $flags, $mode, $uid, $pid,
      $filename, $filesize, $fileuid, $filegid, $filemode,
      $filedevice, ) = @acc;
    $deny = &checkAccess(@acc);
    $rc = Dazuko::IO::ReturnAccess($ref, $deny);
    print $rc == 0 ? "" : "not ", "ok 7\n";
    # to make this not loop in the automatic test scenario
    last;
  }
  print $rc == 0 ? "" : "not ", "ok 8\n";
} else {
  # we're not allowed to block the test, fake OK results
  print "ok 6\n";
  print "ok 7\n";
  print "ok 8\n";
}

$rc = Dazuko::IO::Unregister();
print $rc == 0 ? "" : "not ", "ok 9\n";

1;

# ----- E O F ---------------------------------------------------
